<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2015 IMIA net based solutions (info@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaBaseExt\Domain\Model;

use IMIA\ImiaBaseExt\Annotation\SQL;

/**
 * @package     imia_base_ext
 * @subpackage  Domain\Model
 * @author      David Frerich <d.frerich@imia.de>
 * @author      Sascha Lorenz <s.lorenz@imia.de>
 *
 * @SQL\Table(name="sys_file_metadata")
 */
abstract class FileMetadata extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{
    /**
     * @SQL\Column(name="file", create=false)
     *
     * @var integer
     */
    protected $file;

    /**
     * @SQL\Column(name="categories", create=false)
     *
     * @var integer
     */
    protected $categories;

    /**
     * @SQL\Column(name="title", create=false)
     *
     * @var string
     */
    protected $title;

    /**
     * @SQL\Column(name="description", create=false)
     *
     * @var string
     */
    protected $description;

    /**
     * @SQL\Column(name="alternative", create=false)
     *
     * @var string
     */
    protected $alternative;

    /**
     * @SQL\Column(name="width", create=false)
     *
     * @var integer
     */
    protected $width;

    /**
     * @SQL\Column(name="height", create=false)
     *
     * @var integer
     */
    protected $height;


    public function getFile()
    {
        return $this->file;
    }

    public function setFile($file)
    {
        $this->file = $file;

        return $this;
    }

    public function getCategories()
    {
        return $this->categories;
    }

    public function setCategories($categories)
    {
        $this->categories = $categories;

        return $this;
    }

    public function getTitle()
    {
        return $this->title;
    }

    public function setTitle($title)
    {
        $this->title = $title;

        return $this;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function setDescription($description)
    {
        $this->description = $description;

        return $this;
    }

    public function getAlternative()
    {
        return $this->alternative;
    }

    public function setAlternative($alternative)
    {
        $this->alternative = $alternative;

        return $this;
    }

    public function getWidth()
    {
        return $this->width;
    }

    public function setWidth($width)
    {
        $this->width = $width;

        return $this;
    }

    public function getHeight()
    {
        return $this->Height;
    }

    public function setHeight($height)
    {
        $this->height = $height;

        return $this;
    }
}